VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CHotmailCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'storage for properties
Private m_Username As String
Private m_Password As String
Private m_NewMessages As Integer

Dim WithEvents m_Socket As Winsock
Attribute m_Socket.VB_VarHelpID = -1

'events
Public Event Status(StatusCode As EMCStatus, StatusDesc As String)
Public Event Error(ErrorCode As EMCError, ErrorDesc As String)

'private data
Private iBatch       As Integer 'holds the current batch number we need to send
Private sNewHost     As String
Private sNewUrl      As String  'new server and url after redirection (see below)
Private asCookies(6) As String  'stores cookies received, required for receiving mailbox (contains encrypted information read by server)
Private iCookie      As Integer 'stores current cookie number, as there are numerous different ones
Private sMailData    As String  'once we begin to receive data about mailbox, this is the string that stores it so we can retrieve the information
Private bReadBox     As Boolean 'whether or not we are receiving the mailbox data
Private iBoxBatch    As Integer 'batch number of the data we are receiving

Private colBuffer    As Collection

Private iLastAction As EMCStatus
Public Sub AttachSocket(WinsockControl As Winsock)
Set m_Socket = WinsockControl
End Sub
Public Sub Cancel()
m_Socket.Close
End Sub
Private Sub eventError(ErrorCode As EMCError, Optional ErrorDesc As String = "")
If ErrorDesc = "" Then
    RaiseEvent Error(ErrorCode, GetErrorDesc(ErrorCode))
Else
    RaiseEvent Error(ErrorCode, ErrorDesc)
End If
ResetSocket
End Sub
Private Sub eventStatus(StatusCode As EMCStatus, Optional StatusDesc As String = "")
If StatusDesc = "" Then
    RaiseEvent Status(StatusCode, GetStatusDesc(StatusCode))
Else
    RaiseEvent Status(StatusCode, StatusDesc)
End If
End Sub
Public Sub Execute()

If m_Socket Is Nothing Then
    eventError eMCError_NoSocket
    Exit Sub
End If

If m_Username = "" Then
    eventError eMCError_NoUsername
    Exit Sub
End If

If m_Password = "" Then
    eventError eMCError_NoPassword
    Exit Sub
End If

'reset socket
ResetSocket

eventStatus eMCStatus_Connecting
'm_Socket.RemoteHost = "lc5.law5.hotmail.passport.com"
m_Socket.RemoteHost = "lc2.law13.hotmail.passport.com"
m_Socket.RemotePort = 80
m_Socket.Connect

Set colBuffer = New Collection
End Sub
Public Property Get NewMessages() As Integer
NewMessages = m_NewMessages
End Property

Private Function ResetSocket()
With m_Socket
    .Close
    .Protocol = sckTCPProtocol
End With

Set colBuffer = Nothing

End Function
Public Sub SetLogin(User As String, Pass As String)
m_Username = User
m_Password = Pass
End Sub
Public Property Let Username(m As String)
m_Username = Trim$(m)
End Property
Public Property Let Password(m As String)
m_Password = Trim$(m)
End Property
Public Property Get Password() As String
Password = m_Password
End Property
Public Property Set Socket(m As Winsock)
Set m_Socket = m
End Property
Public Property Get Socket() As Winsock
Set Socket = m_Socket
End Property
Public Property Get Username() As String
Username = m_Username
End Property



Private Sub m_Socket_Connect()
Dim sData As String ' holds data to be sent to server

Select Case iBatch
    Case 0
        eventStatus eMCStatus_HM_SendingLogin
        sData = MakeString(0)  ' make first batch of data to send
    Case 1
        eventStatus eMCStatus_HM_RequestingMailbox
        sData = MakeString(1) ' make second batch of data
    Case 2
        sData = MakeString(2)
End Select

' send data to server
m_Socket.SendData sData
End Sub
Private Function MakeString(Connection As Integer) As String
Dim strdata As String ' for temporary storage of data to send
'Dim feed As String
'feed = (Chr(13) & Chr(10)) ' carriage return & linefeed

Select Case Connection
    Case 0 'first batch of data sent, contains login information
        Dim content As String
        content$ = "login=" & m_Username & "&domain=hotmail.com&passwd=" & m_Password & "&enter=Sign+in&sec=no&curmbox=ACTIVE&js=yes&_lang=&beta=&ishotmail=1&id=2&ct=963865176"
        strdata = "POST /cgi-bin/dologin HTTP/1.1" & vbCrLf & "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/vnd.ms-powerpoint, application/vnd.ms-excel, application/msword, */*" & vbCrLf
        strdata = strdata & "Accept -Language: en -us" & vbCrLf & "Content-Type: application/x-www-form-urlencoded" & vbCrLf
        strdata = strdata & "Accept -Encoding: gzip , deflate" & vbCrLf & "User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)" & vbCrLf
        strdata = strdata & "Host: lc5.law5.hotmail.passport.com" & vbCrLf
        strdata = strdata & "Content-Length: " & Len(content$) & vbCrLf & "Connection: Keep -Alive" & vbCrLf & vbCrLf
        strdata = strdata & content$ & vbCrLf & vbCrLf
        MakeString = strdata
    Case 1 'we get relocated to a new hotmail server (NewHost) containing the mailbox. here we request a new page, because contained in the url of the page (NewUrl) is our encrypted login and password
        strdata = "GET /" & sNewUrl & " HTTP/1.1" & vbCrLf
        strdata = strdata & "User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)" & vbCrLf
        strdata = strdata & "Host: " & sNewHost & vbCrLf
        strdata = strdata & "Cookie: MC1=V=2&GUID=B8E9C518070C49B18A9884F543033C33; mh=ENCA; MSPDom=; MSPAuth=; MSPProf=; MSPVis=; LO=; HMSC0899=; HMP1=1; HMSC0899="
        strdata = strdata & vbCrLf & vbCrLf
         '& feed
        MakeString = strdata
    Case 2 'finally, we request the mailbox on the new server, by sending the cookies we received with all the encrypted information needed
        strdata = "GET " & sNewUrl & " HTTP/1.1" & vbCrLf
        strdata = strdata & "User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)" & vbCrLf
        strdata = strdata & "Host: " & sNewHost & vbCrLf
        strdata = strdata & "Connection: Keep-Alive" & vbCrLf
        strdata = strdata & "Cookie: HMP1=1; " & asCookies(4) & "; MSPDom=; " & asCookies(1) & "; " & asCookies(2) & "; MSPVis=1; LO=;" & vbCrLf & vbCrLf
        MakeString = strdata
End Select
End Function
Private Sub m_Socket_DataArrival(ByVal bytesTotal As Long)

If m_Socket.State <> sckConnected Then eventError eMCError_Disconnected

'when changing batch number, changing iNewBatch will set iBatch after the For loop
Dim iNewBatch As Integer
iNewBatch = iBatch

Dim sNewData As String 'data received from server
Dim sTemp As String

Dim sInData As String, asInData() As String, i As Long

m_Socket.PeekData sInData
If Right(sInData, 2) <> vbCrLf Then
    i = InStr(StrReverse(sInData), vbLf & vbCr)
    If i <> 0 Then
        i = Len(sInData) - i + 1
        m_Socket.GetData sInData, , i
    Else
        sInData = ""
    End If
Else
    m_Socket.GetData sInData
End If

asInData = Split(sInData, vbCrLf)

For i = 0 To UBound(asInData)
    sNewData = asInData(i)

    Select Case iBatch 'depending on which batch of data we receive, we will do different actions
        Case 0
            'if login and password are correct, hotmail redirects to a new url
'            Clipboard.SetText sNewData
            If InStr(1, sNewData, "Location:") <> 0 Then
                sTemp = Right(sNewData, Len(sNewData) - Len("Location: "))
                'start after the http://
                sNewHost = Mid$(sTemp, 8, InStr(8, sTemp, "/") - 8) ' here we get the new server address
                'get everything after the server name (first '/' after http://)
                sNewUrl = Right$(sTemp, Len(sTemp) - InStr(8, sTemp, "/")) 'and here we get the new url to request
                
                iNewBatch = 1
                
                eventStatus eMCStatus_HM_FindingServer
                
                'disconnect and reconnect to new server to send data
                m_Socket.Close
                m_Socket.RemoteHost = sNewHost
                m_Socket.Connect 'once we connect, we'll request the new page (NewUrl)
                Exit For
            End If
            'bad login/pass
            If InStr(1, sNewData, "reauthhead.asp") <> 0 Then
                eventError eMCError_BadPassword
                ResetSocket
                Exit For
            End If
        Case 1
            'connected to new server->sends cookies to be re-sent when we request the mailbox
            If InStr(1, sNewData, "Set-Cookie:") <> 0 Then
                asCookies(iCookie) = Mid(sNewData, InStr(1, sNewData, "Set-Cookie:") + 12, Len(sNewData) - (InStr(1, sNewData, "Set-Cookie:") + 12) - (Len(sNewData) - InStr(1, sNewData, ";"))) ' store cookies in array
                iCookie = iCookie + 1
            End If
            'after the server sends all the cookies, it tell us to refresh to the actual mailbox, therefore demanding us to send the cookies back to the server
            If InStr(1, sNewData, "Refresh") <> 0 Then
                sNewUrl = Mid$(sNewData, InStr(1, sNewData, "content=") + 16, Len(sNewData) - (InStr(1, sNewData, "content=") + 16) - 3) 'the url of the final mailbox
            End If
            If InStr(1, sNewData, "</html>") <> 0 Then
                iNewBatch = 2
                m_Socket.Close ' get ready to send final data
                m_Socket.Connect
            End If
        Case 2
            'if all correct data was sent correctly, on the third time we begin to receive the mailbox data
            eventStatus eMCStatus_HM_ProcessingMailbox
            If InStr(1, sNewData, "title.asp") <> 0 Then ' here is where the number of new messages can be read
                bReadBox = True ' begin storing incoming batches (pages) into the variable 'BoxData'
                iBoxBatch = 0 ' we will only store 10 batches of data, as that is all we need to find the new messages
                sMailData = sNewData
            End If
            If bReadBox = True Then
                iBoxBatch = iBoxBatch + 1
                sMailData = sMailData & sNewData
                If iBoxBatch = 10 Then
                    ' we now have all the crucial mailbox source stored, and we are ready to extract the number of new messages from it.
                    ' By storing more batches, you can also extract other information that you want. this is just shown as an example.
                    m_Socket.Close
                    Dim Location As Integer, Offset As Integer, Length As Integer
                    Location = InStr(1, sMailData, "new")
'                    Clipboard.Clear
'                    Clipboard.SetText sMailData
                    Offset = InStr(Location - 5, sMailData, ">") + 1
                    Length = Location - (Location - Offset)
                    
                    m_NewMessages = Mid(sMailData, Length, Len(sMailData) - Offset - (Len(sMailData) - Location) - 1) ' store value of new messages
                    eventStatus eMCStatus_Success
                    
                    ResetSocket
                    
                    Exit Sub
                    
                    ' Because you have accessed the entire source of the mailbox, to retrieve other useful information such as who sent you what, the subject line of the new mail,
                    ' and even check any messages in your mailbox, all you need to do is store more batches of the data, and find this information from the source, or find the url containing
                    ' the new messages, and request for that page as shown in the function MakeString(). If you have any questions, comments, or suggestions, please feel free to
                    ' email me at:   nmjblue@hotmail.com
                End If
            End If
    End Select
    DoEvents
Next i

iBatch = iNewBatch
End Sub
Private Sub m_Socket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
eventError CVar(Number), Description
End Sub
