VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CMailCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'storage for properties
Private WithEvents m_Socket As Winsock
Attribute m_Socket.VB_VarHelpID = -1
Private m_ServerType As EMCServerType
Private m_ServerHost As String
Private m_ServerPort As Long

Private m_Username As String
Private m_Password As String

Private m_NewMessages As Integer

Private m_LastEvent As EMCEvent
Private m_LastError As EMCError
Private m_LastStatus As EMCStatus
Private m_LastErrorDesc As String
Private m_LastStatusDesc As String

Private m_Complete As Boolean

'events
Public Event Error(ErrorCode As EMCError, ErrorDesc As String)
Public Event Status(StatusCode As EMCStatus, StatusDesc As String)
Public Event Success(NewMessages As Integer)

'private data
Dim WithEvents hmCheck  As CHotmailCheck
Attribute hmCheck.VB_VarHelpID = -1
Dim WithEvents popCheck As CPOP3Check
Attribute popCheck.VB_VarHelpID = -1
Public Sub AttachSocket(WinsockControl As Winsock)
Set m_Socket = WinsockControl
End Sub
Public Sub Cancel()
Select Case m_ServerType
    Case eMC_ServerType_Hotmail
        hmCheck.Cancel
        Set hmCheck = Nothing
    Case eMC_ServerType_POP3
        popCheck.Cancel
        Set popCheck = Nothing
End Select
End Sub
Public Property Get Complete() As Boolean
Complete = m_Complete
End Property
Public Property Get Error()
Error = m_LastError
End Property
Private Sub eventSuccess()
RaiseEvent Success(m_NewMessages)
m_Complete = True
End Sub
Public Property Get LastEvent() As EMCEvent
LastEvent = m_LastEvent
End Property
Public Property Set Socket(m As Winsock)
Set m_Socket = m
End Property
Public Property Get Socket() As Winsock
Set Socket = m_Socket
End Property
Private Sub eventError(ErrorCode As EMCError, Optional ErrorDesc As String = "")
If ErrorDesc = "" Then ErrorDesc = GetErrorDesc(ErrorCode)
    
RaiseEvent Error(ErrorCode, ErrorDesc)
m_LastEvent = eMCEvent_Error
m_LastError = ErrorCode
m_LastErrorDesc = ErrorDesc

m_Complete = True
End Sub
Private Sub eventStatus(StatusCode As EMCStatus, Optional StatusDesc As String = "")
If StatusDesc = "" Then
    RaiseEvent Status(StatusCode, GetStatusDesc(StatusCode))
Else
    RaiseEvent Status(StatusCode, StatusDesc)
End If

m_LastEvent = eMCEvent_Status
m_LastStatus = StatusCode
m_LastStatusDesc = StatusDesc
End Sub
Public Sub Execute()

If m_Socket Is Nothing Then
    eventError eMCError_NoSocket
    Exit Sub
End If

If m_Username = "" Then
    eventError eMCError_NoUsername
    Exit Sub
End If

If m_Password = "" Then
    eventError eMCError_NoPassword
    Exit Sub
End If

Select Case m_ServerType
    Case eMC_ServerType_NotAssigned
        eventError eMCError_NoServerType
    Case eMC_ServerType_Hotmail
        Set hmCheck = New CHotmailCheck
        hmCheck.AttachSocket m_Socket
        hmCheck.SetLogin m_Username, m_Password
        hmCheck.Execute
    Case eMC_ServerType_POP3
        Set popCheck = New CPOP3Check
        popCheck.AttachSocket m_Socket
        popCheck.SetLogin m_Username, m_Password
        popCheck.SetServer m_ServerHost, m_ServerPort
        popCheck.Execute
End Select

End Sub
Public Property Get NewMessages() As Integer
NewMessages = m_NewMessages
End Property
Public Sub SetLogin(User As String, Pass As String)
m_Username = User
m_Password = Pass
End Sub
Public Sub SetServer(ServerType As EMCServerType, Optional ServerHost As String = "", Optional ServerPort As Long = 110)
m_ServerType = ServerType
m_ServerHost = ServerHost
m_ServerPort = ServerPort
End Sub
Public Property Let ServerPort(m As Long)
    m_ServerPort = m
End Property
Public Property Get ServerPort() As Long
    ServerPort = m_ServerPort
End Property
Public Property Let ServerHost(m As String)
    m_ServerHost = m
End Property
Public Property Get ServerHost() As String
    ServerHost = m_ServerHost
End Property
Public Property Let ServerType(m As EMCServerType)
m_ServerType = m
End Property
Public Property Get Status() As EMCStatus
Status = m_LastStatus
End Property
Public Property Get StatusDescription()
StatusDescription = m_LastStatusDesc
End Property
Public Property Get ErrorDescription()
ErrorDescription = m_LastErrorDesc
End Property
Public Property Get Username() As String
Username = m_Username
End Property
Public Property Let Username(m As String)
m_Username = Trim$(m)
End Property
Public Property Let Password(m As String)
m_Password = Trim$(m)
End Property
Public Property Get Password() As String
Password = m_Password
End Property
Public Property Get ServerType() As EMCServerType
ServerType = m_ServerType
End Property
Private Sub Class_Initialize()
m_ServerPort = 110
End Sub
Private Sub hmCheck_Error(ErrorCode As EMCError, ErrorDesc As String)
eventError ErrorCode, ErrorDesc
End Sub
Private Sub hmCheck_Status(StatusCode As EMCStatus, StatusDesc As String)
eventStatus StatusCode, StatusDesc
If StatusCode = eMCStatus_Success Then
    m_NewMessages = hmCheck.NewMessages
    eventSuccess
End If
End Sub

Private Sub popCheck_Error(ErrorCode As EMCError, ErrorDesc As String)
eventError ErrorCode, ErrorDesc
End Sub
Private Sub popCheck_Status(StatusCode As EMCStatus, StatusDesc As String)
eventStatus StatusCode, StatusDesc
If StatusCode = eMCStatus_Success Then
    m_NewMessages = popCheck.NewMessages
    eventSuccess
End If
End Sub
