Attribute VB_Name = "MAccounts"
Option Explicit

Global Accounts As CSettings
Global colAccounts As Collection

Private Const SETTINGSFILE = "accounts.ini"

Private Const CRYPTKEY = "a3%[&"
Public Function GetAccount(AccountName As String, Optional bCreate As Boolean = False) As CAccount
Dim Account As CAccount, bFound As Boolean
For Each Account In colAccounts
    If Account.Name = AccountName Then
        Set GetAccount = Account
        Exit For
    End If
Next Account

'none found
If (Not bFound) And (bCreate) Then
    Set Account = New CAccount
    'initialize port
    Account.Name = AccountName
    Account.ServerPort = 110
    colAccounts.Add Account
    Set GetAccount = Account
End If
End Function
Public Function GetAccountIndex(AccountName As String) As Long
Dim i As Long, Account As CAccount
For i = 1 To colAccounts.Count
    Set Account = colAccounts.Item(i)
    If Account.Name = AccountName Then
        GetAccountIndex = i
        Exit Function
    End If
Next i
End Function
Public Sub LoadAccounts()

Dim ce As New CRC4, sPassword As String

Set Accounts = New CSettings

'load accounts into collection
With Accounts

    Accounts.Filename = joinFilePath(App.Path, SETTINGSFILE)
    Accounts.LoadSettings

    'get account count
    Dim iCount As Long
    iCount = .GetSetting("Accounts", 0)
    
    'load accounts
    'clear collection of accounts
    Set colAccounts = New Collection
    Dim i As Long, sAccount As String, Account As CAccount
    
    For i = 1 To iCount
        'get name of account
        sAccount = .GetSetting("Account" & i, "")
        
        'build account, and read in properties
        Set Account = New CAccount
        Account.Name = sAccount
        Account.Username = .GetSetting(sAccount & "->Username", "")
        sPassword = .GetSetting(sAccount & "->Password", "")
        Account.Password = ce.DecryptString(sPassword, CRYPTKEY)
        Account.ServerType = .GetSetting(sAccount & "->ServerType", 0)
        Account.ServerHost = .GetSetting(sAccount & "->ServerHost", "")
        Account.ServerPort = .GetSetting(sAccount & "->ServerPort", 110)
        Account.MailClient = .GetSetting(sAccount & "->MailClient", "")
        Account.MailClientEXE = .GetSetting(sAccount & "->MailClientEXE", "")
        
        colAccounts.Add Account
    Next i
End With
End Sub
Public Function RemoveAccount(AccountName As String) As Boolean
colAccounts.Remove GetAccountIndex(AccountName)
End Function
Public Function RenameAccount(AccountFrom As String, AccountTo As String) As Boolean
Dim Account As CAccount
'make sure New name doesn't already exist
Set Account = GetAccount(AccountTo)
If (Account Is Nothing) Then
    Set Account = GetAccount(AccountFrom)
    'make sure old account name does exist
    If Not (Account Is Nothing) Then
        Account.Name = AccountTo
        RenameAccount = True
    End If
End If
End Function
Public Sub SaveAccounts()

Dim ce As New CRC4, sPassword As String

With Accounts

    .ClearSettings

    'save number of accounts
    .AddSetting "Accounts", colAccounts.Count
        
    Dim i As Long, Account As CAccount, sAccount As String
    For i = 1 To colAccounts.Count
        Set Account = colAccounts.Item(i)
        sAccount = Account.Name
        'save name
        .AddSetting "Account" & i, sAccount
        'save properties
        .AddSetting sAccount & "->Username", Account.Username
        sPassword = ce.EncryptString(Account.Password, CRYPTKEY)
        .AddSetting sAccount & "->Password", sPassword
        .AddSetting sAccount & "->ServerType", Account.ServerType
        .AddSetting sAccount & "->ServerHost", Account.ServerHost
        .AddSetting sAccount & "->ServerPort", Account.ServerPort
        .AddSetting sAccount & "->MailClient", Account.MailClient
        .AddSetting sAccount & "->MailClientEXE", Account.MailClientEXE
    Next i
    
    .SaveSettings
End With

End Sub
