Attribute VB_Name = "MCheckValue"
Option Explicit
Private Function ToHex(Key As Currency, Digits As Long) As String
'prevent overflow
Key = Key Mod (16 ^ Digits)

Dim sKey As String
sKey = Hex$(Key)

'add zeros if needed
ToHex = String(Digits - Len(sKey), "0") & sKey
End Function
Private Function FixString(ByVal s As String, LenKey As Long) As String

If Len(s) > LenKey Then
    'reason the string is not just trimmed is because crackers try to find a maximum key length by trying strings like
    '   unformed@hotmai.com
    '   unformed@hotmail.comx
    'to see if they rteurn the same check value
    
    Dim Src As String, Dest As String
    Src = Left(s, LenKey)
    Dest = Mid(s, LenKey + 1)
    
    s = AddString(Src, Dest)
Else
    
    Dim i As Long, lens As Long, iChar As Long
    lens = Len(s)
    For i = lens + 1 To LenKey
        iChar = Asc(Mid(s, Modx(i, lens), 1))
        s = s & Chr(Modx(iChar * i * lens, 255))
    Next i
End If

FixString = s
End Function
Private Function AddString(ByVal Src As String, ByVal Dest As String) As String
Dim i As Long, iSrc As Long
Dim lenSrc As Long, lenDest As Long

lenSrc = Len(Src)
lenDest = Len(Dest)

Dim iCharSrc As Long, iCharDest As Long

For i = 1 To lenDest
    iSrc = Modx(i, lenSrc)
    iCharSrc = Asc(Mid(Src, iSrc, 1))
    iCharDest = Asc(Mid(Dest, i, 1))
    'this is just to make it dirty...
    iCharSrc = Modx(Sqr(iCharSrc * iCharDest * i), 255)
    Mid(Src, iSrc, 1) = Chr(iCharSrc)
Next i
AddString = Src
End Function
Public Function JoinKeys(Key1 As String, Key2 As String, Digits As Long) As String
On Error GoTo ErrHandler

Dim k1 As Currency, k2 As Currency, l As Long
k1 = "&H" & Key1
k2 = "&H" & Key2

JoinKeys = ToHex(k1 Xor k2, Digits)

Exit Function

ErrHandler:
JoinKeys = "0000"
End Function
Private Function Modx(a As Long, b As Long) As Long
Dim c As Long
c = a Mod b
If c = 0 Then c = b
Modx = c
End Function
Public Function GetCheckValue(ByVal s As String, LenKey As Long, Digits As Long) As String
Dim i As Long, iSum As Currency, iNum As Currency

If s <> "" Then s = FixString(s, LenKey)

For i = 1 To Len(s)
    Debug.Print Mid(s, i, 1) & "(" & Asc(Mid(s, i, 1)) & "):" & i
    iNum = Asc(Mid(s, i, 1)) * (2 ^ i)
    iSum = iSum + iNum
Next i

GetCheckValue = ToHex(iSum, Digits)
End Function

