Attribute VB_Name = "MRegistry"
Option Explicit

Private Const NO_ERROR = 0    '  dderror

'reg value types
Private Const REG_SZ = 1                         ' Unicode nul terminated string
Private Const REG_EXPAND_SZ = 2                  ' Unicode nul terminated string
Private Const REG_BINARY = 3                     ' Free form binary
Private Const REG_DWORD = 4                      ' 32-bit number
Private Const REG_DWORD_LITTLE_ENDIAN = 4        ' 32-bit number (same as REG_DWORD)
Private Const REG_DWORD_BIG_ENDIAN = 5           ' 32-bit number
Private Const REG_LINK = 6                       ' Symbolic Link (unicode)
Private Const REG_MULTI_SZ = 7                   ' Multiple Unicode strings

'permissions
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Private Const SYNCHRONIZE = &H100000

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

Private Const KEY_EVENT = &H1     '  Event contains key event record

'dwOptions
Private Const REG_OPTION_NON_VOLATILE = 0       ' Key is preserved when system is rebooted
Private Const REG_OPTION_VOLATILE = 1           ' Key is not preserved when system is rebooted - WinNT/2000 only
Private Const REG_OPTION_BACKUP_RESTORE = 4     ' open for backup or restore

'error message
Private Const FORMAT_MESSAGE_ALLOCATE_BUFFER = &H100
Private Const FORMAT_MESSAGE_ARGUMENT_ARRAY = &H2000
Private Const FORMAT_MESSAGE_FROM_HMODULE = &H800
Private Const FORMAT_MESSAGE_FROM_STRING = &H400
Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Private Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200
Private Const FORMAT_MESSAGE_MAX_WIDTH_MASK = &HFF

Public Enum EREGHKEY
    HKEY_CLASSES_ROOT& = &H80000000
    HKEY_CURRENT_CONFIG& = &H80000005
    HKEY_CURRENT_USER& = &H80000001
    HKEY_LOCAL_MACHINE& = &H80000002
    HKEY_USERS& = &H80000003
    HKEY_PERFORMANCE_DATA& = &H80000004 'WinNT/2000 only
    HKEY_DYN_DATA& = &H80000006         'Win95/98 only
End Enum

Public Enum EREGTYPE
    eREG_SZ = REG_SZ
    eREG_EXPAND_SZ = REG_EXPAND_SZ
    eREG_BINARY = REG_BINARY
    eREG_DWORD = REG_DWORD
    eREG_DWORD_LITTLE_ENDIAN = REG_DWORD_LITTLE_ENDIAN
    eREG_DWORD_BIG_ENDIAN = REG_DWORD_BIG_ENDIAN
    eREG_LINK = REG_LINK
    eREG_MULTI_SZ = REG_MULTI_SZ
End Enum

Public Type REGVALUE
    ValueName As String
    DataType As EREGTYPE
    Data As Variant
End Type

Private Type ACL
        AclRevision As Byte
        Sbz1 As Byte
        AclSize As Integer
        AceCount As Integer
        Sbz2 As Integer
End Type

Private Type SECURITY_DESCRIPTOR
        Revision As Byte
        Sbz1 As Byte
        Control As Long
        Owner As Long
        Group As Long
        Sacl As ACL
        Dacl As ACL
End Type

Private Declare Function fRegCloseKey Lib "advapi32.dll" Alias "RegCloseKey" (ByVal hKey As Long) As Long
Private Declare Function fRegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function fRegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function fRegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function fRegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpftLastWriteTime As Long) As Long
Private Declare Function fRegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Private Declare Function fRegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function fRegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, ByVal lpftLastWriteTime As Long) As Long
Private Declare Function fRegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function fRegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.

Private Declare Function ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" (ByVal lpSrc As String, ByVal lpDst As String, ByVal nSize As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Public Function GetErrorDescription(ErrorCode As Long) As String
Dim sMsg As String, lLen As Long
sMsg = Space(255)
lLen = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, ErrorCode, 0, sMsg, Len(sMsg), 0)
GetErrorDescription = Left(sMsg, lLen)
End Function
Public Function RegDelKey(hKey As EREGHKEY, Path As String, Optional Recursive As Boolean = False) As Long
'Win95/98: RegDeleteKey deletes all subkeys and values
'WinNT/2K: RegDeleteKey only deletes empty keys
'therefore force compliance by manual checking

Dim lResult As Long, hSubKey As Long
Dim nKeys As Long, nValues As Long, lMaxKeyLen As Long, lMaxValLen As Long

'open key
lResult = fRegOpenKeyEx(hKey, Path, 0, KEY_ALL_ACCESS, hSubKey)

'get number of subkeys and values
lResult = fRegQueryInfoKey(hSubKey, 0, 0, 0, nKeys, lMaxKeyLen, 0, nValues, lMaxValLen, 0, 0, 0)

If lResult = NO_ERROR Then
    If Recursive Then
        Dim i As Long, sKey As String, sValue As String, lKeyLen As Long, lValLen As Long
        'delete values
        For i = 0 To nValues - 1
            lValLen = lMaxValLen + 1 'need to allocate space for null char

            sValue = String$(lValLen, Chr$(0)) 'init buffer for value name

            'retrieve value info
            lResult = fRegEnumValue(hSubKey, i, sValue, lValLen, 0, 0, 0, 0)
            
            sValue = Left$(sValue, lValLen)
            
            'delete value
            lResult = fRegDeleteValue(hSubKey, sValue)
        Next i
        'delete keys
        For i = 0 To nKeys - 1
            lKeyLen = lMaxKeyLen + 1
            sKey = String(lKeyLen, Chr$(0))
            
            lResult = fRegEnumKeyEx(hSubKey, i, sKey, lKeyLen, 0, vbNullString, 0, 0)
            
            sKey = Left(sKey, lKeyLen)
            
            'delete key
            RegDelKey hSubKey, sKey, True
            
        Next i
        
        RegDelKey = fRegDeleteKey(hSubKey, "")
        
    Else
        'if no subkeys or values, delete key
        If (nKeys + nValues) = 0 Then RegDelKey = fRegDeleteKey(hSubKey, "")
    End If
    
End If

fRegCloseKey hSubKey
End Function
Public Function RegEnumKeys(hKey As EREGHKEY, Path As String, ByRef asKey() As String) As Long
Dim lResult As Long

'open key
Dim hSubKey As Long
lResult = fRegOpenKeyEx(hKey, Path, 0, KEY_READ, hSubKey)

If lResult = NO_ERROR Then
    Dim nKeys As Long, lMaxKeyLen As Long
    
    'get number of subkeys and max subkey length
    lResult = fRegQueryInfoKey(hSubKey, 0, 0, 0, nKeys, lMaxKeyLen, 0, 0, 0, 0, 0, 0)
    
    If lResult = NO_ERROR Then
        
        'init storage for key names
        ReDim asKey(nKeys - 1)
        
        Dim sKey As String 'buffer for key names
        
        Dim i As Long, lKeyLen As Long
        For i = 0 To nKeys - 1
                
            lKeyLen = lMaxKeyLen + 1 'need to allocate space for null char
            sKey = String(lKeyLen, Chr$(0)) 'init buffer for key name
        
            'retrieve keyname; length of name (w/o terminating null char) is returned in lKeyLen
            lResult = fRegEnumKeyEx(hSubKey, i, sKey, lKeyLen, 0, vbNullString, 0, 0)
            
            asKey(i) = Left$(sKey, lKeyLen)
            
        Next i
        
    End If
End If

fRegCloseKey hSubKey
End Function
Public Function RegDelValue(hKey As String, Path As String, Value As String) As Boolean
Dim lResult As Long, hSubKey As Long
'open with permission
lResult = fRegOpenKeyEx(hKey, Path, 0, KEY_SET_VALUE, hSubKey)
If lResult = NO_ERROR Then
    lResult = fRegDeleteValue(hSubKey, Value)
    fRegCloseKey hSubKey
End If

'return TRUE/FALSE
RegDelValue = (lResult = NO_ERROR)
End Function
Public Function RegEnumValues(hKey As EREGHKEY, Path As String, asValue() As REGVALUE) As Long
Dim lResult As Long

'open key
Dim hSubKey As Long
lResult = fRegOpenKeyEx(hKey, Path, 0, KEY_READ, hSubKey)

If lResult = NO_ERROR Then
    Dim nValues As Long, lMaxValLen As Long, lMaxDataLen As Long
    
    'get number of subkeys and max subkey length
    lResult = fRegQueryInfoKey(hSubKey, 0, 0, 0, 0, 0, 0, nValues, lMaxValLen, lMaxDataLen, 0, 0)
    
    If lResult = NO_ERROR Then
        
        'init storage for value names
        ReDim asValue(nValues - 1)
        
        Dim sValue As String 'buffer for value name
        Dim ayData() As Byte 'buffer for value data
        Dim lType As Long    'buffer for data type
        Dim lValLen As Long  'buffer for value length
        Dim lDataLen As Long 'buffer for data length
        
        Dim i As Long
        For i = 0 To nValues - 1
                
            lValLen = lMaxValLen + 1 'need to allocate space for null char
            lDataLen = lMaxDataLen
            sValue = String$(lValLen, Chr$(0)) 'init buffer for value name

            'retrieve value info
            lResult = fRegEnumValue(hSubKey, i, sValue, lValLen, 0, lType, ayData(0), lDataLen)
            
            With asValue(i)
                .ValueName = sValue
                .DataType = lType
                Select Case lType
                    Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
                        'convert byte array to string
                        Dim sData As String
                        sData = Left$(StrConv(ayData, vbUnicode), lDataLen)
                        Select Case lType
                            Case REG_SZ
                                .Data = sData
                            Case REG_EXPAND_SZ 'expand string
                                'get length of expanded string
                                lDataLen = ExpandEnvironmentStrings(sData, vbNullString, 0)
                                
                                If lDataLen > 0 Then
                                    'retrieve expanded string
                                    Dim sTemp As String
                                    sTemp = sData
                                    sData = String(lDataLen, Chr$(0))
                                    lDataLen = ExpandEnvironmentStrings(sTemp, sData, lDataLen)
                                    .Data = Left$(sData, lDataLen - 1)
                                End If
                            Case REG_MULTI_SZ 'build array
                                .Data = Split(sData, 0)
                        End Select
                    Case REG_BINARY, REG_DWORD
                        'convert byte array to long
                        Dim lData As Long
                        CopyMemory lData, ayData(0), lDataLen
                        .Data = lData
                End Select
            End With
            
        Next i
        
    End If
End If

fRegCloseKey hSubKey
End Function
Public Function RegGetValue(hKey As EREGHKEY, Path As String, Value As String)

Dim lResult As Long

'open subkey with read permissions
Dim hSubKey As Long
lResult = fRegOpenKeyEx(hKey, Path, 0, KEY_QUERY_VALUE, hSubKey)

If lResult = NO_ERROR Then
    
    'get type and length of value
    Dim lType As Long, lLenData As Long
    lResult = fRegQueryValueEx(hSubKey, Value, 0, lType, ByVal 0, lLenData)
    
    Select Case lType
        Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
            'initialize buffer space
            Dim sData As String
            sData = String(lLenData, Chr$(0))
            
            'retrieve data
            lResult = fRegQueryValueEx(hSubKey, Value, 0, 0, ByVal sData, lLenData)
            
            'if successful, trim at first null char
            If lResult = NO_ERROR Then
                
                Select Case lType
                    Case REG_SZ
                        RegGetValue = Left$(sData, lLenData - 1) 'remove the zero-terminator
                
                    Case REG_EXPAND_SZ 'expand string
                        'get length of expanded string
                        lLenData = ExpandEnvironmentStrings(sData, vbNullString, 0)
                        
                        If lLenData > 0 Then
                            'retrieve expanded string
                            Dim sTemp As String
                            sTemp = sData
                            sData = String(lLenData, Chr$(0))
                            lLenData = ExpandEnvironmentStrings(sTemp, sData, lLenData)
                            RegGetValue = Left$(sData, lLenData - 1)
                        End If
                    
                    Case REG_MULTI_SZ 'string array
                        RegGetValue = Split(sData, 0)
                        
                End Select
            End If
            
        Case REG_BINARY, REG_DWORD
            Dim iData As Integer
            'retrieve data
            lResult = fRegQueryValueEx(hSubKey, Value, 0, 0, iData, lLenData)
            
            If lResult = NO_ERROR Then RegGetValue = iData
            
    End Select
End If

fRegCloseKey hSubKey
End Function
Public Function RegSetValue(hKey As EREGHKEY, Path As String, Value As String, ByVal Data, ByVal DataType As EREGTYPE) As Long

Dim lResult As Long

'create/open subkey with write permissions
Dim hSubKey As Long
lResult = fRegOpenKeyEx(hKey, Path, 0, KEY_SET_VALUE, hSubKey)

If lResult = NO_ERROR Then
    Select Case DataType
        Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
            Dim sData As String
            sData = Data
            lResult = fRegSetValueEx(hSubKey, Value, 0, DataType, ByVal sData, Len(sData))
        Case REG_BINARY, REG_DWORD
            Dim lData As Long
            lData = Data
            lResult = fRegSetValueEx(hSubKey, Value, 0, DataType, lData, Len(lData))
    End Select
End If

fRegCloseKey hSubKey

Debug.Assert (lResult = 0)
'MsgBox GetErrorDescription(lResult)

RegSetValue = lResult
End Function
